/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.human.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.kintai.common.action.MosPHumanAction;
import jp.mosp.kintai.common.dto.MKihonDto;
import jp.mosp.kintai.human.vo.HumanKihonCardVo;

/**
 * @author yoshida
 *
 */
public class HumanKihonCardAction extends MosPHumanAction {
	
	// コマンド
	/**
	 * 
	 */
	public static final String	CMD_HUMAN_BASIS_SHOW	= "H1020";
	/**
	 * 
	 */
	public static final String	CMD_HUMAN_BASIS_SELECT	= "H1021";
	private static final String	CMD_HUMAN_BASIS_INSERT	= "H1022";
	private static final String	CMD_HUMAN_BASIS_UPDATE	= "H1023";
	

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_HUMAN_BASIS_SHOW)) {
			// 表示(新規)
			show();
		} else if (cmd.equals(CMD_HUMAN_BASIS_SELECT)) {
			// 表示(社員コードで情報を検索)
			select();
		} else if (cmd.equals(CMD_HUMAN_BASIS_INSERT)) {
			// 登録
			insert();
		} else if (cmd.equals(CMD_HUMAN_BASIS_UPDATE)) {
			// 更新
			update();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new HumanKihonCardVo();
	}
	
	/**
	 * 初期処理
	 */
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// HUMAN権限確認
		confirmHumanAuth();
		HumanKihonCardVo vo = (HumanKihonCardVo)getVo();
		// パラメータ取得
		vo.setParams(request);
		// ボタン内容設定
		setListButton();
		// プルダウン設定
		setPulldown();
		// 機能ボタン設定
		setFunctionButton(false);
	}
	
	@Override
	protected void show() throws Exception {
		HumanKihonCardVo vo = (HumanKihonCardVo)getVo();
		// モード設定
		vo.setMode(HumanKihonCardVo.MODE_INSERT);
		// 選択社員コード取得
		// VO初期化
		vo.initFields();
		// 選択社員コード取得
		vo.setTxtKCode(vo.getTxtChangeKCode());
		Date date = DateUtil.getSystemDate();
		vo.setPltEntranceYear(String.valueOf(MospUtility.getYear(date)));
		vo.setPltEntranceMonth(String.valueOf(MospUtility.getMonth(date)));
		vo.setPltEntranceDay(String.valueOf(MospUtility.getDay(date)));
		// 機能ボタン設定
		setFunctionButton(true);
	}
	
	@Override
	protected void select() throws Exception {
		HumanKihonCardVo vo = (HumanKihonCardVo)getVo();
		// 表示(社員コードで情報を検索)
		// 選択社員コード取得
		String kCode = "";
		if (StringUtil.isNotNull(vo.getTxtChangeKCode())) {
			kCode = vo.getTxtChangeKCode();
		} else if (StringUtil.isNotNull(key1)) {
			kCode = key1;
		} else {
			kCode = vo.getTxtKCode();
		}
		// 人事基本情報取得
		getHumanBasisInfo(kCode);
		// セッションにDTOをセット
		setStoredDto();
	}
	
	@Override
	protected void insert() throws Exception {
		HumanKihonCardVo vo = (HumanKihonCardVo)getVo();
		// パラメータの妥当性確認
		vo.validate();
		// マスタデータ存在確認
		chkDuplicate(humanBasisDao().findForKey(vo.getTxtKCode()));
		// 登録処理
		String message = regist();
		// コミット
		commit();
		// 人事基本情報取得
		getHumanBasisInfo(vo.getTxtKCode());
		// メッセージ設定
		vo.setMessage(message);
		// セッションにDTOをセット
		setStoredDto();
	}
	
	@Override
	protected void update() throws Exception {
		HumanKihonCardVo vo = (HumanKihonCardVo)getVo();
		// セッション保持DTO取得
		getStoredDto();
		// パラメータの妥当性確認
		vo.validate();
		// 登録処理
		String message = regist();
		// コミット
		commit();
		// 人事基本情報取得
		getHumanBasisInfo(vo.getTxtKCode());
		// メッセージ設定
		vo.setMessage(message);
		// セッションにDTOをセット
		setStoredDto();
	}
	
	/**
	 * プルダウン設定
	 * @throws Exception	例外処理が発生した場合
	 */
	protected void setPulldown() throws Exception {
		HumanKihonCardVo vo = (HumanKihonCardVo)getVo();
		// プルダウン設定
		if (vo.aryPltSectionAll != null) {
			return;
		}
		vo.aryPltOfficeAll = getOfficeArrayAll();
		vo.aryPltOffice = getOfficeArray();
		vo.aryPltSectionAll = getSectionArrayAll();
		vo.aryPltSection = getSectionArrayForHuman();
		vo.aryPltPositionAll = getPositionArrayAll();
		vo.aryPltPosition = getPositionPltArray();
		vo.aryPltRetirement = StringUtil.getRetirementFlagArray();
		final int former = 80;
		vo.aryPltYear = StringUtil.getYearArray(MospUtility.getYear(DateUtil.getSystemDate()), former, 1);
		vo.aryPltMonth = StringUtil.getMonthArray();
		vo.aryPltDay = StringUtil.getDayArray();
	}
	
	/**
	 * 情報取得処理
	 * @param kCode 取得対象社員コード
	 * @throws Exception	例外処理が発生した場合
	 */
	protected void getHumanBasisInfo(String kCode) throws Exception {
		HumanKihonCardVo vo = (HumanKihonCardVo)getVo();
		// 人事基本情報取得
		findHumanBasisInfo(kCode, false);
		// 対象データ存在確認
		if (mKihonDto == null) {
			vo.addErrMessage(getMessage(CommonConst.MSG_NO_HUMAN_DATA, ""));
			vo.setTxtChangeKCode(kCode);
			show();
			return;
		}
		// VO初期化
		vo.initFields();
		vo.setTxtChangeKCode(kCode);
		// VOに情報を設定
		vo.setFields(mKihonDto);
		vo.setMode(HumanKihonCardVo.MODE_UPDATE);
		// セッション保持用DTO設定
		storedmKihonDto = mKihonDto;
		// 排他情報設定
		String editor = setExclusive(CommonConst.EXC_HUMAN_BASIS, user.getUserId(), kCode);
		if (editor != null) {
			vo.addErrMessage(getMessage(CommonConst.MSG_EXCLUSIVE, editor));
		}
		setNeedExclusive(true);
	}
	
	/**
	 * 登録処理
	 * @return メッセージ
	 * @throws Exception	例外処理が発生した場合
	 */
	protected String regist() throws Exception {
		HumanKihonCardVo vo = (HumanKihonCardVo)getVo();
		// DTO準備
		mKihonDto = storedmKihonDto;
		if (mKihonDto == null) {
			mKihonDto = new MKihonDto();
		}
		vo.setDtoFields(mKihonDto);
		// 存在確認
		String message = "";
		MKihonDto duplicateDto = humanBasisDao().findForUpdate(mKihonDto.getKCode());
		if (duplicateDto == null) {
			// 新規登録
			humanBasisDao().insert(mKihonDto);
			applyHistory(mKihonDto.getKCode(), false);
			message = getMessage(MospConst.MSG_INSERT, "");
		} else {
			// 更新
			humanBasisDao().update(mKihonDto);
			applyHistory(mKihonDto.getKCode(), true);
			message = getMessage(MospConst.MSG_UPDATE, "");
		}
		return message;
	}
	
}
